# -*- coding: utf-8 -*-

from traceback import format_exc
import re, os, sys
version = sys.version
if version.startswith("2"):
    reload(sys)
    sys.setdefaultencoding("utf-8")
else:
    import imp
    imp.reload(sys)


def installpython3(packagedir, packagename, unzipdir):
    try:
        release = re.search(r'[0-9].[0-9]', os.popen("cat /etc/redhat-release").read())
        if release:
            if release.group().split(".")[0] == "6" and packagename == "python3.7.12-6.zip":
                if not os.path.exists(unzipdir):
                    os.makedirs(unzipdir)

            elif release.group().split(".")[0] == "7" and packagename == "python3.7.12-7.zip":
                if not os.path.exists(unzipdir):
                    os.makedirs(unzipdir)

            if os.path.exists(unzipdir):
                print("正在安装%s" % (packagedir + packagename))
                print("unzip -u -o %s -d %s" % (packagedir + packagename, unzipdir))
                os.popen("unzip -u -o %s -d %s" % (packagedir + packagename, unzipdir))

                print("ln -s %s %s" % (unzipdir + "/bin/python3", '/usr/local/bin'))
                os.popen("ln -s %s %s" % (unzipdir + "/bin/python3", '/usr/local/bin'))

                print("ln -s %s %s" % (unzipdir + "/bin/pip3", '/usr/local/bin'))
                if os.system("ln -s %s %s" % (unzipdir + "/bin/pip3", '/usr/local/bin')) == 0:
                    print("安装完成 %s" % unzipdir)
                    return 0

    except:
        print(format_exc())
        return 1


def ubuntu_installpython2(packagedir, packagename, unzipdir):
    try:
        os_ver = os.popen("cat /etc/lsb-release |grep -w 'DISTRIB_RELEASE' |awk -F '=' '{print $2}'")
        ver = os_ver.read().strip()
        if ver.startswith("20"):
            print("操作系统为ubuntu20版本，使用自带python2，并执行pip安装脚本")
            os.system("rm -fr /usr/bin/python && ln -s /usr/bin/python2.7 /usr/bin/python")
            os.system("python /usr/local/os_unify_script/get-pip2.py")
            return 0
        elif ver.startswith("22"):
            if os.path.exists(unzipdir):
                print("正在安装%s" % (packagedir + packagename))
                print("unzip -u -o %s -d %s" % (packagedir + packagename, unzipdir))
                result = os.system("unzip -u -o %s -d %s " % (packagedir + packagename, unzipdir))
                if result == 0:
                    print("ln -s %s %s" % (unzipdir + "python2.7/bin/python", '/usr/bin'))
                    os.popen("ln -s %s %s" % (unzipdir + "python2.7/bin/python", '/usr/bin'))
                    print("ln -s %s %s" % (unzipdir + "python2.7/bin/pip2", '/usr/bin/pip2'))
                    if os.system("ln -s %s %s" % (unzipdir + "python2.7/bin/pip2", '/usr/bin/pip2')) == 0:
                        os.system("mv %s %s" % (unzipdir + "python2.7/mysql_os/*","/usr/lib"))
                        print("安装完成 %s" % packagename)
                        return 0
    except:
        print(format_exc())
        return 1

def installpython2(packagedir, packagename, unzipdir):
    try:
        release = re.search(r'[0-9].[0-9]', os.popen("cat /etc/redhat-release").read())
        if release:
            if release.group().split(".")[0] == "6" and packagename == "python27-6.zip":
                print(os.popen('''sed -i "s/python.*/python2.6 -tt/" /usr/bin/yum-config-manager''').read())
                print(os.popen('''sed -i "s/python.*/python2.6/" /usr/bin/yum''').read())
                if not os.path.exists(unzipdir):
                    os.makedirs(unzipdir)

            elif release.group().split(".")[0] == "7" and packagename == "python27-7.zip":
                print(os.popen('''sed -i "s/python.*/python2 -tt/" /usr/bin/yum-config-manager''').read())
                print(os.popen('''sed -i "s/python.*/python2 -tt/" /usr/bin/yum''').read())
                print(os.popen('''sed -i "s/python.*/python2 /" /usr/libexec/urlgrabber-ext-down''').read())
                if not os.path.exists(unzipdir):
                    os.makedirs(unzipdir)

            if os.path.exists(unzipdir):
                print("正在安装%s" % (packagedir + packagename))
                print("unzip -u -o %s -d %s" % (packagedir + packagename, unzipdir))
                os.popen("unzip -u -o %s -d %s" % (packagedir + packagename, unzipdir))

                print("mv /usr/bin/python{,.bak}")
                os.popen("\mv /usr/bin/python{,.bak}")

                print("ln -s %s %s" % (unzipdir + "python27/bin/python", '/usr/bin'))
                os.popen("ln -s %s %s" % (unzipdir + "python27/bin/python", '/usr/bin'))

                print("ln -s %s %s" % (unzipdir + "python27/bin/pip", '/usr/bin'))
                if os.system("ln -s %s %s" % (unzipdir + "python27/bin/pip", '/usr/bin')) == 0:
                    print("安装完成 %s" % unzipdir)
                    return 0
    except:
        print(format_exc())
        return 1


def ubuntu_installflume(packagedir, packagename, unzipdir):
    try:
        if not os.path.exists(unzipdir):
            os.makedirs(unzipdir)

        if os.path.exists(unzipdir):
            print("正在安装%s" % (packagedir + packagename))
            print("unzip -u -o %s -d %s" % (packagedir + packagename, unzipdir))
            result = os.system("unzip -u -o %s -d %s" % (packagedir + packagename, unzipdir))
            if result == 0:
                # 添加java环境变量
                print(" 添加java环境变量")
                java_home = """
                if [ $(cat /etc/profile |grep "JAVA_HOME" |wc -l) -eq 0 ];then
                    echo  "export JAVA_HOME=%s \nexport CLASSPATH=.:\${JAVA_HOME}/jre/lib/rt.jar:\${JAVA_HOME}/lib/dt.jar:\${JAVA_HOME}/lib/tools.jar\nexport PATH=\$PATH:\${JAVA_HOME}/bin" >> /etc/profile
                fi
                """ % (unzipdir + "java1.8")
                os.popen(java_home)

                # rc.local添加flume开机启动项
                flume_rclocal = """
                if [ $(cat /etc/rc.local | grep "flume-release" |wc -l ) -eq 0  ];then
                    echo  'nohup %s/bin/flume-ng agent --conf /usr/local/flume-release/conf --conf-file %s/conf/flume.conf --name agent -Dflume.root.logger=INFO,console >/dev/null 2>&1 &' >> /etc/rc.local 
                fi
                """ % (unzipdir + "/flume-release", unzipdir + "/flume-release")
                os.popen(flume_rclocal)

                # 停止flume程序 后面重新启动
                stop_flume = """
                if [ $(ps aux |grep '/usr/local/flume-release/conf/flume.conf' |grep -v grep |wc -l) -gt 0  ];then
                    ps aux |grep '/usr/local/flume-release/conf/flume.conf' |grep -v grep|awk '{print $2}' |xargs kill -9
                fi
                """
                os.popen(stop_flume)

                # 启动flume
                start_flume = """
                    .  /etc/profile 
                    nohup %s/bin/flume-ng agent --conf /usr/local/flume-release/conf --conf-file %s/conf/flume.conf --name agent -Dflume.root.logger=INFO,console >/dev/null 2>&1 &
                    if [  $(ps aux |grep flume |grep -v grep |wc -l) -gt 0  ];then
                        echo "flume start successfully"
                    else
                        echo "flume start fail"
                    fi
                """ % (unzipdir + "flume-release", unzipdir + "flume-release")
                print(start_flume)
                if os.system(start_flume) == 0:
                    print("flume安装并启动完成")
                    return 0
    except:
        print(format_exc())
        return 1

def installflume(packagedir, packagename, unzipdir):
    try:
        if not os.path.exists(unzipdir):
            os.makedirs(unzipdir)

        if os.path.exists(unzipdir):
            print("正在安装%s" % (packagedir + packagename))
            print("unzip -u -o %s -d %s" % (packagedir + packagename, unzipdir))
            os.popen("unzip -u -o %s -d %s" % (packagedir + packagename, unzipdir))

            # 添加java环境变量
            print(" 添加java环境变量")
            java_home = """
            if [ $(cat /etc/profile |grep "JAVA_HOME" |wc -l) -eq 0 ];then
            	echo -e "export JAVA_HOME=%s \nexport CLASSPATH=.:\${JAVA_HOME}/jre/lib/rt.jar:\${JAVA_HOME}/lib/dt.jar:\${JAVA_HOME}/lib/tools.jar\nexport PATH=\$PATH:\${JAVA_HOME}/bin" >> /etc/profile
            fi
            """ % (unzipdir + "java1.8")
            os.popen(java_home)

            # rc.local添加flume开机启动项
            flume_rclocal = """
            if [ $(cat /etc/rc.d/rc.local | grep "flume-release" |wc -l ) -eq 0  ];then
                echo -e 'nohup %s/bin/flume-ng agent --conf /usr/local/flume-release/conf --conf-file %s/conf/flume.conf --name agent -Dflume.root.logger=INFO,console >/dev/null 2>&1 &' >> /etc/rc.d/rc.local 
            fi
            """ % (unzipdir + "/flume-release", unzipdir + "/flume-release")
            os.popen(flume_rclocal)

            # 停止flume程序 后面重新启动
            stop_flume = """
            if [ $(ps aux |grep '/usr/local/flume-release/conf/flume.conf' |grep -v grep |wc -l) -gt 0  ];then
                ps aux |grep '/usr/local/flume-release/conf/flume.conf' |grep -v grep|awk '{print $2}' |xargs kill -9
            fi

            """
            os.popen(stop_flume)

            # 启动flume
            start_flume = """
                source  /etc/profile 
                nohup %s/bin/flume-ng agent --conf /usr/local/flume-release/conf --conf-file %s/conf/flume.conf --name agent -Dflume.root.logger=INFO,console >/dev/null 2>&1 &
                if [  $(ps aux |grep flume |grep -v grep |wc -l) -gt 0  ];then
                    echo "flume start successfully"
                else
                    echo "flume start fail"
                fi
            """ % (unzipdir + "flume-release", unzipdir + "flume-release")
            print(start_flume)
            if os.system(start_flume) == 0:
                return 0

    except:
        print(format_exc())
        return 1


def ubuntu_installmonitor4(packagedir, packagename, unzipdir):
    try:
        print("正在安装%s" % (packagedir + packagename))
        print("unzip -u -o %s -d %s" % (packagedir + packagename, "/usr/local/elves-agent/apps"))
        if os.path.exists("/usr/local/elves-agent/apps/mft"):
            os.system("unzip -u -o %s -d %s" % (packagedir + packagename, "/usr/local/elves-agent/apps"))
            return 0
        else:
            os.system("unzip -u -o %s -d %s" % (packagedir + packagename, "/usr/local/elves-agent/apps"))
            os_ver = os.popen("cat /etc/lsb-release |grep -w 'DISTRIB_RELEASE' |awk -F '=' '{print $2}'")
            os_ver = os_ver.read()
            if os_ver.strip().startswith('20.'):
                os.system("rm -fr /usr/bin/python && ln -s /usr/bin/python2.7 /usr/bin/python")
                # os.system("sed -i 's/python/python2/g' /usr/local/elves-agent/apps/mft/mft.py")
                # os.system("python2 /usr/local/elves-agent/apps/mft/mft.py")
                # os.system("sed -i 's/python/python2/g' /home/monitor4/client/core/core.py")
            os.system("python /usr/local/elves-agent/apps/mft/mft.py")
            print("\n")
            if os.system("chmod 600 /var/spool/cron/crontabs/monitor4") == 0:
                print("第四版监控安装完成")
                return 0
    except:
        print(format_exc())
        return 1

def installmonitor4(packagedir, packagename, unzipdir):
    try:
        print("正在安装%s" % (packagedir + packagename))
        print("unzip -u -o %s -d %s" % (packagedir + packagename, "/usr/local/elves-agent/apps"))
        if os.path.exists("/usr/local/elves-agent/apps/mft"):
            os.popen("unzip -u -o %s -d %s" % (packagedir + packagename, "/usr/local/elves-agent/apps"))
            return 0
        else:
            os.popen("unzip -u -o %s -d %s" % (packagedir + packagename, "/usr/local/elves-agent/apps"))
            if os.system("/usr/bin/python /usr/local/elves-agent/apps/mft/mft.py") == 0:
                print("\n")
                return 0
    except:
        print(format_exc())
        return 1


def ubuntu_installelves(packagedir, packagename, unzipdir):
    try:
        if not os.path.exists(unzipdir):
            os.makedirs(unzipdir)

        if os.path.exists(unzipdir):
            print("正在安装%s" % (packagedir + packagename))
            print("unzip -u -o %s -d %s" % (packagedir + packagename, unzipdir))
            result = os.system("unzip -u -o %s -d %s" % (packagedir + packagename, unzipdir))

            if result == 0:
                os.popen("sed -i /elves/d /etc/rc.local")
                print('''sed  -i "s/elves_ip/$(hostname -I |xargs -n 1  | egrep '^10.|^192.')/g"  %s''' % (
                            unzipdir + "/conf/cfg.json"))
                os.popen('''sed  -i "s/elves_ip/$(hostname -I |xargs -n 1  | egrep '^10.|^192.')/g"  %s''' % (
                            unzipdir + "/conf/cfg.json"))

                stopelves = """
                    if [ $(ps aux|grep elves-agent |grep -v grep |wc -l) -gt 0 ];then
                        ps aux|grep '/usr/local/elves-agent' |grep -v grep | awk '{print $2}' | xargs kill -9
                    fi
                """
                os.popen(stopelves)

                print("""chmod +x %s/control""" % unzipdir)
                os.popen("""chmod +x %s/control""" % unzipdir)

                print("""chmod +x %s/bin/elves-agent""" % unzipdir)
                os.popen("""chmod +x %s/bin/elves-agent""" % unzipdir)
                print("""sed -i 's#rc\.d\/##g' %s/control""" % unzipdir)
                if os.system("""sed -i 's#rc\.d\/##g' %s/control""" % unzipdir) == 0:
                    startelves = """
                        cd %s && ./control install && ./control start
                        if [ $(ps aux |grep elves |grep -v grep |wc -l ) -gt 0 ];then
                            echo "start elves-agent successfully"
                        else
                            echo "start elves-agent fail"
                        fi
                    """ % (unzipdir)
                    print(startelves)
                    if os.system(startelves) == 0:
                        print("elves安装并启动完成")
                        return 0
    except:
        print(format_exc())
        return 1

def installelves(packagedir, packagename, unzipdir):
    try:
        if not os.path.exists(unzipdir):
            os.makedirs(unzipdir)

        if os.path.exists(unzipdir):
            print("正在安装%s" % (packagedir + packagename))
            print("unzip -u -o %s -d %s" % (packagedir + packagename, unzipdir))
            os.popen("unzip -u -o %s -d %s" % (packagedir + packagename, unzipdir))

            os.popen("sed -i /elves/d /etc/rc.local")
            print('''sed  -i "s/elves_ip/$(hostname -I |xargs -n 1  | egrep '^10.|^192.')/g"  %s''' % (
                    unzipdir + "/conf/cfg.json"))
            os.popen(
                '''sed  -i "s/elves_ip/$(hostname -I |xargs -n 1  | egrep '^10.|^192.')/g"  %s''' % (unzipdir + "/conf/cfg.json"))

            stopelves = """
                if [ $(ps aux|grep elves-agent |grep -v grep |wc -l) -gt 0 ];then
                    ps aux|grep '/usr/local/elves-agent' |grep -v grep | awk '{print $2}' | xargs kill -9
                fi
            """
            os.popen(stopelves)

            print("""chmod +x %s/control""" % unzipdir)
            os.popen("""chmod +x %s/control""" % unzipdir)

            print("""chmod +x %s/bin/elves-agent""" % unzipdir)
            os.popen("""chmod +x %s/bin/elves-agent""" % unzipdir)
            startelves = """
                cd %s && ./control install && ./control start
                if [ $(ps aux |grep elves |grep -v grep |wc -l ) -gt 0 ];then
                    echo "start elves-agent successfully"
                else
                    echo "start elves-agent fail"
                fi
            """ % (unzipdir)
            print(startelves)
            if os.system(startelves) == 0:
                return 0
    except:
        print(format_exc())
        return 1


def ubuntu_installIpset(packagedir, packagename, unzipdir):
    try:
        if not os.path.exists(unzipdir):
            os.makedirs(unzipdir)
        if os.path.exists(unzipdir):
            instalShell = """unzip %s -d %s && ln -s /usr/local/ipset/sbin/ipset /usr/local/sbin/ipset""" % (
            packagedir + packagename, unzipdir)
            print(instalShell)
            if os.system(instalShell) == 0:
                print("ipset安装已完成")
                return 0
    except:
        print(format_exc())
        return 1

def installIpset(packagedir, packagename, unzipdir):
    try:
        if not os.path.exists(unzipdir):
            os.makedirs(unzipdir)
        if os.path.exists(unzipdir):
            instalShell = """
            if [ ! -d /usr/local/ipset ] && [ $(awk -F"." '{print $1}' /etc/redhat-release  |awk '{print $NF}') -eq 6 ] ;then
                echo "正在安装ipset..."
                unzip %s -d %s
                rm -f /usr/local/sbin/ipset && ln -s /usr/local/ipset/sbin/ipset /usr/local/sbin/ipset
                export PATH=$PATH:/usr/local/ipset/sbin && echo 'export PATH=$PATH:/usr/local/ipset/sbin' >> /etc/profile
                source /etc/profile
            else
                echo "ipset 已安装"
            fi
            """ % (packagedir + packagename, unzipdir)
            print(instalShell)
            if os.system(instalShell) == 0:
                return 0
    except:
        print(format_exc())
        return 1

def ubuntu_installprometheus(packagedir, packagename, unzipdir):
    try:
        if not os.path.exists(unzipdir):
            os.makedirs(unzipdir)

        if os.path.exists(unzipdir):
            print("正在安装%s" % (packagedir + packagename))
            print("unzip -u -o %s -d %s" % (packagedir + packagename, unzipdir + "prometheus-2.47.2"))
            result = os.system("unzip -u -o %s -d %s" % (packagedir + packagename, unzipdir + "prometheus-2.47.2"))
            if result == 0:
                print("""%s/promtool check config %s/prometheus.yml""" % (unzipdir + "prometheus-2.47.2",unzipdir + "prometheus-2.47.2"))
                os.popen("""%s/promtool check config %s/prometheus.yml""" % (unzipdir + "prometheus-2.47.2",unzipdir + "prometheus-2.47.2"))
                startprometheus = """ nohup /usr/local/prometheus-2.47.2/prometheus --storage.tsdb.retention.time=7d --web.enable-remote-write-receiver  --web.enable-lifecycle --config.file=/usr/local/prometheus-2.47.2/prometheus.yml --storage.tsdb.path="/data/prometheus-data" > /usr/local/prometheus-2.47.2/prometheus.log 2>&1 & 
                                     if [ $(ps aux |grep prometheus |grep -v grep |wc -l) -gt 0  ];then
                                        echo "start prometheus successfully"
                                     else
                                        echo "start prometheus fail"
                                     fi
                """
                print(startprometheus)
                if os.system(startprometheus) == 0:
                    return 0

    except:
        print(format_exc())
        return 1

def installprometheus(packagedir, packagename, unzipdir):
    try:
        if not os.path.exists(unzipdir):
            os.makedirs(unzipdir)

        if os.path.exists(unzipdir):
            print("正在安装%s" % (packagedir + packagename))
            print("unzip -u -o %s -d %s" % (packagedir + packagename, unzipdir + "prometheus-2.47.2"))
            result = os.system("unzip -u -o %s -d %s" % (packagedir + packagename, unzipdir + "prometheus-2.47.2"))
            if result == 0:
                print("""%s/promtool check config %s/prometheus.yml""" % (unzipdir + "prometheus-2.47.2",unzipdir + "prometheus-2.47.2"))
                os.popen("""%s/promtool check config %s/prometheus.yml""" % (unzipdir + "prometheus-2.47.2",unzipdir + "prometheus-2.47.2"))
                startprometheus = """ nohup /usr/local/prometheus-2.47.2/prometheus --storage.tsdb.retention.time=7d --web.enable-remote-write-receiver --web.enable-lifecycle --config.file=/usr/local/prometheus-2.47.2/prometheus.yml --storage.tsdb.path="/data/prometheus-data" > /usr/local/prometheus-2.47.2/prometheus.log 2>&1 & 
                                     if [ $(ps aux |grep prometheus |grep -v grep |wc -l) -gt 0  ];then
                                        echo "start prometheus successfully"
                                     else
                                        echo "start prometheus fail"
                                     fi
                """
                print(startprometheus)
                if os.system(startprometheus) == 0:
                    return 0

    except:
        print(format_exc())
        return 1

def ubuntu_installnode(packagedir, packagename, unzipdir):
    try:
        if not os.path.exists(unzipdir):
            os.makedirs(unzipdir)

        if os.path.exists(unzipdir):
            print("正在安装%s" % (packagedir + packagename))
            print("unzip -u -o %s -d %s" % (packagedir + packagename, unzipdir + "node_exporter-1.6.1"))
            result = os.system("unzip -u -o %s -d %s" % (packagedir + packagename, unzipdir + "node_exporter-1.6.1"))
            if result == 0:
                startnode = """nohup /usr/local/node_exporter-1.6.1/node_exporter --web.listen-address=:9100 &
                            if [ $(ps aux |grep node_exporter |grep -v grep |wc -l) -gt 0  ];then
                                        echo "start node_exporter successfully"
                                     else
                                        echo "start node_exporter fail"
                                     fi
                            """.format(unzipdir)
                print(startnode)

            if os.system(startnode) == 0:
                return 0
    except:
        print(format_exc())
        return 1

def installnode(packagedir, packagename, unzipdir):
    try:
        if not os.path.exists(unzipdir):
            os.makedirs(unzipdir)

        if os.path.exists(unzipdir):
            print("正在安装%s" % (packagedir + packagename))
            print("unzip -u -o %s -d %s" % (packagedir + packagename, unzipdir + "node_exporter-1.6.1"))
            result = os.system("unzip -u -o %s -d %s" % (packagedir + packagename, unzipdir + "node_exporter-1.6.1"))
            if result == 0:
                startnode = """nohup /usr/local/node_exporter-1.6.1/node_exporter --web.listen-address=:9100 &
                            if [ $(ps aux |grep node_exporter |grep -v grep |wc -l) -gt 0  ];then
                                        echo "start node_exporter successfully"
                                     else
                                        echo "start node_exporter fail"
                                     fi
                            """.format(unzipdir)
                print(startnode)

            if os.system(startnode) == 0:
                return 0
    except:
        print(format_exc())
        return 1
